/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.26
        Device            :  PIC18F87K22
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set AD_L01 aliases
#define GLCD_RES_TRIS               TRISAbits.TRISA0
#define GLCD_RES_LAT                LATAbits.LATA0
#define GLCD_RES_PORT               PORTAbits.RA0
#define GLCD_RES_ANS                ANCON0bits.ANSEL0
#define GLCD_RES_SetHigh()            do { PORTAbits.RA0 = 1; } while(0)
#define GLCD_RES_SetLow()             do { PORTAbits.RA0 = 0; } while(0)
#define GLCD_RES_Toggle()             do { PORTAbits.RA0 = ~PORTAbits.RA0; } while(0)
#define GLCD_RES_GetValue()           PORTAbits.RA0
#define GLCD_RES_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define GLCD_RES_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define GLCD_RES_SetAnalogMode()  do { ANCON0bits.ANSEL0 = 1; } while(0)
#define GLCD_RES_SetDigitalMode() do { ANCON0bits.ANSEL0 = 0; } while(0)

// get/set AD_T01 aliases
#define GLCD_CS2_TRIS               TRISAbits.TRISA1
#define GLCD_CS2_LAT                PORTAbits.RA1
#define GLCD_CS2_PORT               PORTAbits.RA1
#define GLCD_CS2_ANS                ANCON0bits.ANSEL1
#define GLCD_CS2_SetHigh()            do { PORTAbits.RA1 = 1; } while(0)
#define GLCD_CS2_SetLow()             do { PORTAbits.RA1 = 0; } while(0)
#define GLCD_CS2_Toggle()             do { PORTAbits.RA1 = ~PORTAbits.RA1; } while(0)
#define GLCD_CS2_GetValue()           PORTAbits.RA1
#define GLCD_CS2_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define GLCD_CS2_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define GLCD_CS2_SetAnalogMode()  do { ANCON0bits.ANSEL1 = 1; } while(0)
#define GLCD_CS2_SetDigitalMode() do { ANCON0bits.ANSEL1 = 0; } while(0)

// get/set AD_T02 aliases
#define GLCD_CS1_TRIS               TRISAbits.TRISA2
#define GLCD_CS1_LAT                LATAbits.LATA2
#define GLCD_CS1_PORT               PORTAbits.RA2
#define GLCD_CS1_ANS                ANCON0bits.ANSEL2
#define GLCD_CS1_SetHigh()            do { PORTAbits.RA2 = 1; } while(0)
#define GLCD_CS1_SetLow()             do { PORTAbits.RA2 = 0; } while(0)
#define GLCD_CS1_Toggle()             do { PORTAbits.RA2 = ~PORTAbits.RA2; } while(0)
#define GLCD_CS1_GetValue()           PORTAbits.RA2
#define GLCD_CS1_SetDigitalInput()    do { TRISAbits.TRISA2 = 1; } while(0)
#define GLCD_CS1_SetDigitalOutput()   do { TRISAbits.TRISA2 = 0; } while(0)
#define GLCD_CS1_SetAnalogMode()  do { ANCON0bits.ANSEL2 = 1; } while(0)
#define GLCD_CS1_SetDigitalMode() do { ANCON0bits.ANSEL2 = 0; } while(0)

// get/set V_45_A aliases
#define RA_03_TRIS               TRISAbits.TRISA3
#define RA_03_LAT                LATAbits.LATA3
#define RA_03_PORT               PORTAbits.RA3
#define RA_03_ANS                ANCON0bits.ANSEL3
#define RA_03_SetHigh()            do { PORTAbits.RA3 = 1; } while(0)
#define RA_03_SetLow()             do { PORTAbits.RA3 = 0; } while(0)
#define RA_03_Toggle()             do { PORTAbits.RA3 = ~PORTAbits.RA3; } while(0)
#define RA_03_GetValue()           PORTAbits.RA3
#define RA_03_SetDigitalInput()    do { TRISAbits.TRISA3 = 1; } while(0)
#define RA_03_SetDigitalOutput()   do { TRISAbits.TRISA3 = 0; } while(0)
#define RA_03_SetAnalogMode()  do { ANCON0bits.ANSEL3 = 1; } while(0)
#define RA_03_SetDigitalMode() do { ANCON0bits.ANSEL3 = 0; } while(0)

// get/set ENC_A aliases
#define RA_04_TRIS               TRISAbits.TRISA4
#define RA_04_LAT                LATAbits.LATA4
#define RA_04_PORT               PORTAbits.RA4
#define RA_04_SetHigh()            do { PORTAbits.RA4 = 1; } while(0)
#define RA_04_SetLow()             do { PORTAbits.RA4 = 0; } while(0)
#define RA_04_Toggle()             do { PORTAbits.RA4 = ~PORTAbits.RA4; } while(0)
#define RA_04_GetValue()           PORTAbits.RA4
#define RA_04_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define RA_04_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)

// get/set RA_05 aliases
#define RA_05_TRIS               TRISAbits.TRISA5
#define RA_05_LAT                LATAbits.LATA5
#define RA_05_PORT               PORTAbits.RA5
#define RA_05_ANS                ANCON0bits.ANSEL4
#define RA_05_SetHigh()            do { PORTAbits.RA5 = 1; } while(0)
#define RA_05_SetLow()             do { PORTAbits.RA5 = 0; } while(0)
#define RA_05_Toggle()             do { PORTAbits.RA5 = ~PORTAbits.RA5; } while(0)
#define RA_05_GetValue()           PORTAbits.RA5
#define RA_05_SetDigitalInput()    do { TRISAbits.TRISA5 = 1; } while(0)
#define RA_05_SetDigitalOutput()   do { TRISAbits.TRISA5 = 0; } while(0)
#define RA_05_SetAnalogMode()  do { ANCON0bits.ANSEL4 = 1; } while(0)
#define RA_05_SetDigitalMode() do { ANCON0bits.ANSEL4 = 0; } while(0)

// get/set RA_06 aliases
#define RA_06_TRIS               TRISAbits.TRISA6
#define RA_06_LAT                LATAbits.LATA6
#define RA_06_PORT               PORTAbits.RA6
#define RA_06_SetHigh()            do { PORTAbits.RA6 = 1; } while(0)
#define RA_06_SetLow()             do { PORTAbits.RA6 = 0; } while(0)
#define RA_06_Toggle()             do { PORTAbits.RA6 = ~PORTAbits.RA6; } while(0)
#define RA_06_GetValue()           PORTAbits.RA6
#define RA_06_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define RA_06_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)

// get/set RA_07 aliases
#define RA_07_TRIS               TRISAbits.TRISA7
#define RA_07_LAT                LATAbits.LATA7
#define RA_07_PORT               PORTAbits.RA7
#define RA_07_SetHigh()            do { PORTAbits.RA7 = 1; } while(0)
#define RA_07_SetLow()             do { PORTAbits.RA7 = 0; } while(0)
#define RA_07_Toggle()             do { PORTAbits.RA7 = ~PORTAbits.RA7; } while(0)
#define RA_07_GetValue()           PORTAbits.RA7
#define RA_07_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define RA_07_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)

// *  port b   *
// get/set GLCD_D0 aliases
#define GLCD_D0_TRIS               TRISBbits.TRISB0
#define GLCD_D0_LAT                LATBbits.LATB0
#define GLCD_D0_PORT               PORTBbits.RB0
#define GLCD_D0_SetHigh()            do { PORTBbits.RB0 = 1; } while(0)
#define GLCD_D0_SetLow()             do { PORTBbits.RB0 = 0; } while(0)
#define GLCD_D0_Toggle()             do { PORTBbits.RB0 = ~PORTBbits.RB0; } while(0)
#define GLCD_D0_GetValue()           PORTBbits.RB0
#define GLCD_D0_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define GLCD_D0_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)

// get/set GLCD_D1 aliases
#define GLCD_D1_TRIS               TRISBbits.TRISB1
#define GLCD_D1_LAT                LATBbits.LATB1
#define GLCD_D1_PORT               PORTBbits.RB1
#define GLCD_D1_SetHigh()            do { PORTBbits.RB1 = 1; } while(0)
#define GLCD_D1_SetLow()             do { PORTBbits.RB1 = 0; } while(0)
#define GLCD_D1_Toggle()             do { PORTBbits.RB1 = ~PORTBbits.RB1; } while(0)
#define GLCD_D1_GetValue()           PORTBbits.RB1
#define GLCD_D1_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define GLCD_D1_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)

// get/set GLCD_D2 aliases
#define GLCD_D2_TRIS               TRISBbits.TRISB2
#define GLCD_D2_LAT                LATBbits.LATB2
#define GLCD_D2_PORT               PORTBbits.RB2
#define GLCD_D2_SetHigh()            do { PORTBbits.RB2 = 1; } while(0)
#define GLCD_D2_SetLow()             do { PORTBbits.RB2 = 0; } while(0)
#define GLCD_D2_Toggle()             do { PORTBbits.RB2 = ~PORTBbits.RB2; } while(0)
#define GLCD_D2_GetValue()           PORTBbits.RB2
#define GLCD_D2_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define GLCD_D2_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)

// get/set GLCD_D3 aliases
#define GLCD_D3_TRIS               TRISBbits.TRISB3
#define GLCD_D3_LAT                LATBbits.LATB3
#define GLCD_D3_PORT               PORTBbits.RB3
#define GLCD_D3_SetHigh()            do { PORTBbits.RB3 = 1; } while(0)
#define GLCD_D3_SetLow()             do { PORTBbits.RB3 = 0; } while(0)
#define GLCD_D3_Toggle()             do { PORTBbits.RB3 = ~PORTBbits.RB3; } while(0)
#define GLCD_D3_GetValue()           PORTBbits.RB3
#define GLCD_D3_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define GLCD_D3_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)

// get/set GLCD_D4 aliases
#define GLCD_D4_TRIS               TRISBbits.TRISB4
#define GLCD_D4_LAT                LATBbits.LATB4
#define GLCD_D4_PORT               PORTBbits.RB4
#define GLCD_D4_SetHigh()            do { PORTBbits.RB4 = 1; } while(0)
#define GLCD_D4_SetLow()             do { PORTBbits.RB4 = 0; } while(0)
#define GLCD_D4_Toggle()             do { PORTBbits.RB4 = ~PORTBbits.RB4; } while(0)
#define GLCD_D4_GetValue()           PORTBbits.RB4
#define GLCD_D4_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define GLCD_D4_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)

// get/set GLCD_D5 aliases
#define GLCD_D5_TRIS               TRISBbits.TRISB5
#define GLCD_D5_LAT                LATBbits.LATB5
#define GLCD_D5_PORT               PORTBbits.RB5
#define GLCD_D5_SetHigh()            do { PORTBbits.RB5 = 1; } while(0)
#define GLCD_D5_SetLow()             do { PORTBbits.RB5 = 0; } while(0)
#define GLCD_D5_Toggle()             do { PORTBbits.RB5 = ~PORTBbits.RB5; } while(0)
#define GLCD_D5_GetValue()           PORTBbits.RB5
#define GLCD_D5_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define GLCD_D5_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)

// get/set GLCD_D6 aliases
#define GLCD_D6_TRIS               TRISBbits.TRISB6
#define GLCD_D6_LAT                LATBbits.LATB6
#define GLCD_D6_PORT               PORTBbits.RB6
#define GLCD_D6_SetHigh()            do { PORTBbits.RB6 = 1; } while(0)
#define GLCD_D6_SetLow()             do { PORTBbits.RB6 = 0; } while(0)
#define GLCD_D6_Toggle()             do { PORTBbits.RB6 = ~PORTBbits.RB6; } while(0)
#define GLCD_D6_GetValue()           PORTBbits.RB6
#define GLCD_D6_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define GLCD_D6_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)

// get/set GLCD_D7 aliases
#define GLCD_D7_TRIS               TRISBbits.TRISB7
#define GLCD_D7_LAT                LATBbits.LATB7
#define GLCD_D7_PORT               PORTBbits.RB7
#define GLCD_D7_SetHigh()            do { PORTBbits.RB7 = 1; } while(0)
#define GLCD_D7_SetLow()             do { PORTBbits.RB7 = 0; } while(0)
#define GLCD_D7_Toggle()             do { PORTBbits.RB7 = ~PORTBbits.RB7; } while(0)
#define GLCD_D7_GetValue()           PORTBbits.RB7
#define GLCD_D7_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define GLCD_D7_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)

//* port c ***
// get/set CLOCK aliases
#define CLOCK_TRIS               TRISCbits.TRISC0
#define CLOCK_LAT                LATCbits.LATC0
#define CLOCK_PORT               PORTCbits.RC0
#define CLOCK_SetHigh()            do { PORTCbits.RC0 = 1; } while(0)
#define CLOCK_SetLow()             do { PORTCbits.RC0 = 0; } while(0)
#define CLOCK_Toggle()             do { PORTCbits.RC0 = ~PORTCbits.RC0; } while(0)
#define CLOCK_GetValue()           PORTCbits.RC0
#define CLOCK_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define CLOCK_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)

// get/set RC_01 aliases
#define RC_01_TRIS               TRISCbits.TRISC1
#define RC_01_LAT                LATCbits.LATC1
#define RC_01_PORT               PORTCbits.RC1
#define RC_01_SetHigh()            do { PORTCbits.RC1 = 1; } while(0)
#define RC_01_SetLow()             do { PORTCbits.RC1 = 0; } while(0)
#define RC_01_Toggle()             do { PORTCbits.RC1 = ~PORTCbits.RC1; } while(0)
#define RC_01_GetValue()           PORTCbits.RC1
#define RC_01_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define RC_01_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)

// get/set TL_HOD aliases
#define TL_HOD_TRIS               TRISCbits.TRISC2
#define TL_HOD_LAT                LATCbits.LATC2
#define TL_HOD_PORT               PORTCbits.RC2
#define TL_HOD_SetHigh()            do { PORTCbits.RC2 = 1; } while(0)
#define TL_HOD_SetLow()             do { PORTCbits.RC2 = 0; } while(0)
#define TL_HOD_Toggle()             do { PORTCbits.RC2 = ~PORTCbits.RC2; } while(0)
#define TL_HOD_GetValue()           PORTCbits.RC2
#define TL_HOD_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define TL_HOD_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)

// get/set TL_MIN aliases
#define TL_MIN_TRIS               TRISCbits.TRISC3
#define TL_MIN_LAT                LATCbits.LATC3
#define TL_MIN_PORT               PORTCbits.RC3
#define TL_MIN_SetHigh()            do { PORTCbits.RC3 = 1; } while(0)
#define TL_MIN_SetLow()             do { PORTCbits.RC3 = 0; } while(0)
#define TL_MIN_Toggle()             do { PORTCbits.RC3 = ~PORTCbits.RC3; } while(0)
#define TL_MIN_GetValue()           PORTCbits.RC3
#define TL_MIN_SetDigitalInput()    do { TRISCbits.TRISC3 = 1; } while(0)
#define TL_MIN_SetDigitalOutput()   do { TRISCbits.TRISC3 = 0; } while(0)

// get/set GLCD_RS aliases
#define GLCD_04_TRIS               TRISCbits.TRISC4
#define GLCD_04_LAT                LATCbits.LATC4
#define GLCD_04_PORT               PORTCbits.RC4
#define GLCD_04_SetHigh()            do { PORTCbits.RC4 = 1; } while(0)
#define GLCD_04_SetLow()             do { PORTCbits.RC4 = 0; } while(0)
#define GLCD_04_Toggle()             do { PORTCbits.RC4 = ~PORTCbits.RC4; } while(0)
#define GLCD_04_GetValue()           PORTCbits.RC4
#define GLCD_04_SetDigitalInput()    do { TRISCbits.TRISC4 = 1; } while(0)
#define GLCD_04_SetDigitalOutput()   do { TRISCbits.TRISC4 = 0; } while(0)

// get/set RS aliases
#define GLCD_RS_TRIS               TRISCbits.TRISC5
#define GLCD_RS_LAT                LATCbits.LATC5
#define GLCD_RS_PORT               PORTCbits.RC5
#define GLCD_RS_SetHigh()            do { PORTCbits.RC5 = 1; } while(0)
#define GLCD_RS_SetLow()             do { PORTCbits.RC5 = 0; } while(0)
#define GLCD_RS_Toggle()             do { PORTCbits.RC5 = ~PORTCbits.RC5; } while(0)
#define GLCD_RS_GetValue()           PORTCbits.RC5
#define GLCD_RS_SetDigitalInput()    do { TRISCbits.TRISC5 = 1; } while(0)
#define GLCD_RS_SetDigitalOutput()   do { TRISCbits.TRISC5 = 0; } while(0)

// get/set  GLCD_E aliases
#define GLCD_RW_TRIS               TRISCbits.TRISC6
#define GLCD_RW_LAT                LATCbits.LATC6
#define GLCD_RW_PORT               PORTCbits.RC6
#define GLCD_RW_SetHigh()            do { PORTCbits.RC6 = 1; } while(0)
#define GLCD_RW_SetLow()             do { PORTCbits.RC6 = 0; } while(0)
#define GLCD_RW_Toggle()             do { PORTCbits.RC6 = ~PORTCbits.RC6; } while(0)
#define GLCD_RW_GetValue()           PORTCbits.RC6
#define GLCD_RW_SetDigitalInput()    do { TRISCbits.TRISC6 = 1; } while(0)
#define GLCD_RW_SetDigitalOutput()   do { TRISCbits.TRISC6 = 0; } while(0)

// get/set  GLCD_E aliases
#define GLCD_E_TRIS               TRISCbits.TRISC7
#define GLCD_E_LAT                LATCbits.LATC7
#define GLCD_E_PORT               PORTCbits.RC7
#define GLCD_E_SetHigh()            do { PORTCbits.RC7 = 1; } while(0)
#define GLCD_E_SetLow()             do { PORTCbits.RC7 = 0; } while(0)
#define GLCD_E_Toggle()             do { PORTCbits.RC7 = ~PORTCbits.RC7; } while(0)
#define GLCD_E_GetValue()           PORTCbits.RC7
#define GLCD_E_SetDigitalInput()    do { TRISCbits.TRISC7 = 1; } while(0)
#define GLCD_E_SetDigitalOutput()   do { TRISCbits.TRISC7 = 0; } while(0)


/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/